/*
 * $Header: /cvsroot/xwinx/xwinx/xwxb64.c,v 1.5 2001/11/08 20:05:06 guilty Exp $
 * xwxb64.c - base64 encoding function
 * Copyright (C) 2001 Kim Saunders, Sanjay Rao
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "xwxb64.h"

static char 
ebase64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

int encode_base64(unsigned char *lineout, unsigned char *linein, int len) {
	/* is is assumed that lineout is at least 4/3*len+3 bytes or so
	 * 2*len+4 is pretty safe
	 */
	int i, a, b, c, d, x, y, z, t, out;
	int max;

	max = (len / 3) * 3;
	out = 0;
	for (i = 0; i < max; i += 3)
	{
		x = linein[i];
		y = linein[i + 1];
		z = linein[i + 2];

		a = x & 252;
		a = a >> 2;

		b = x & 3;
		b = b << 4;
		t = y & 240;
		t = t >> 4;
		b += t;

		c = y & 15;
		c = c << 2;
		t = z & 192;
		t = t >> 6;
		c += t;

		d = z&63;

		lineout[out++] = ebase64[a];
		lineout[out++] = ebase64[b];
		lineout[out++] = ebase64[c];
		lineout[out++] = ebase64[d];
	}
	switch (len - max)
	{
		case 0:
			break;
		case 1:
			x=linein[i];
			a=x&252;
			a=a>>2;
			b=x&3;
			b=b<<4;
			lineout[out++]=ebase64[a];
			lineout[out++]=ebase64[b];
			lineout[out++]='=';
			lineout[out++]='=';
			break;
		case 2:
			x = linein[i++];
			y = linein[i];
			a = x & 252;
			a = a >> 2;
			b = x & 3;
			b = b << 4;
			t = y & 240;
			t = t >> 4;
			b += t;
			c = y & 15;
			c = c << 2;
			lineout[out++] = ebase64[a];
			lineout[out++] = ebase64[b];
			lineout[out++] = ebase64[c];
			lineout[out++] = '=';
			break;
	}
	lineout[out] = '\0';
	return 0;	
}

