/*
 * $Header: /cvsroot/xwinx/xwinx/xwxhostname.c,v 1.2 2001/11/08 20:05:07 guilty Exp $
 * xwxhostname.c - GetComputerName wrapper since windows.h, Xmd.h incompatible 
 * Copyright (C) 2001 Kim Saunders, Sanjay Rao
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <X11/Xlib.h>
#include "xwx.h"
#include "xwxprint.h"
#include "xwxmemory.h"
#include "xwxhostname.h"

/* xwxhostname uses GetComputerName to return the hostname as a string. It's
 * here because xwxdm.c needs to know the hostname, but using GetComputerName
 * requires including windows.h. xwxdm.c needs Xdmcp.h, which includes Xmd.h,
 * and Xmd.h and windows.h confict (eg, they both declare INT16 data types.
 *
 * The other upshot of all this is that I can't include xwx.h in xwxdm.c,
 * because xwx.h needs windows.h (for HDC, among other things), which is a
 * pain. The things in xwx.h that require windows.h should be moved to another
 * include so that xwx.h can be included in xwxdm.c (which uses Xmd.h for XDMCP
 *
 * It's all a bit of a pain...
 */

char *xwxhostname_gethostname()
{
	LPTSTR host_str;
	DWORD host_siz; 
	char *hostname;
	
	host_siz = MAX_COMPUTERNAME_LENGTH + 1; 
	host_str = xwxmalloc(host_siz);

	GetComputerName(host_str, &host_siz);
	hostname = xwxstrdup(host_str);
	free(host_str);
	
	return(hostname);
}
